Page MenuHomePhabricator

Provide a 'user-watchlist' that lists all recent contributions of a set of users
Open, LowPublic

Description

Add a tab when viewing a user/user-talk page to "watch this user", and a
separate user-watchlist special page which lists the latest contributions from
users on the list.

As an experienced user, I want to follow each step of a newbie I'm coaching, to fix their edits, assist in their discussions, provide guidance in general, without having to watchlist all the pages they may edit, so that all my time is spent helping them. (Also applies to wikimedian in residence etc.)

As an inexperienced user, I want to be sure that I can proceed hand in hand with a more experienced user and that looking after me is part of their regular wiki workflow, so that I feel more confident.

As a wiki trainer with dozens people to follow, I want to have a page where to have an overview of their complete activity, controlled by a "central" list of usernames which I can just edit/past in a single place. I can then act on specific edits/pages/users or just know what's going on overall.

All these should be possible "simply" by watchlisting the users, similar to what the contributions Atom feed does, but within Special:Watchlist. Separate tasks for grouped watchlist, notes about watchlist item, collapsing of edits over multiple days (T90482) etc. etc. would make the feature better but are independent from it.

Details

Reference
bz470

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
DannyH raised the priority of this task from Low to Normal.Dec 15 2015, 8:20 PM
DannyH added a project: Community-Tech.
Johan added a subscriber: Johan.Jan 13 2016, 6:48 AM
IMPORTANT: If you are a community developer interested in working on this task: The Wikimedia Hackathon 2016 (Jerusalem, March 31 - April 3) focuses on #Community-Wishlist-Survey projects. There is some budget for sponsoring volunteer developers. THE DEADLINE TO REQUEST TRAVEL SPONSORSHIP IS TODAY, JANUARY 21. Exceptions can be made for developers focusing on Community Wishlist projects until the end of Sunday 24, but not beyond. If you or someone you know is interested, please REGISTER NOW.
Restricted Application added a subscriber: JEumerus. · View Herald TranscriptJan 21 2016, 2:54 PM
Meno25 removed a subscriber: Meno25.Feb 22 2016, 5:49 PM
Pyro853 added a subscriber: DannyH.Apr 2 2016, 4:10 PM

Hi,

I create an extension available here : https://github.com/Wikifab/extension-UserFollowList
I just present it to @DannyH

@Pyro853 this is great! We will be delighted to know more about this project. Please showcase it today at the end oh the Hackathon. Sign up: https://www.mediawiki.org/wiki/Wikimedia_Hackathon_2016/Showcase

Notes from Hackathon:

An experienced user or a wiki trainer needs an overview of all users mentored. A newcomer may want to see how an experiences user works. But we have to prevent that feature to be an easier way to stalk someone's contributions without notice or make it easier (but there is always a way).

Following and being followed must be a mutual agreement. The idea would be to have a way to give agreement on the fact that you can be followed. On the watchlist, when you add a user, that user will receive a notification to agree (or not). That notification would gather a message from the follower and a link to the follower's talk page. Resume that following may be possible on the watchlist or into preferences page.

Following and being followed must be a mutual agreement. The idea would be to have a way to give agreement on the fact that you can be followed.

I wouldn't want to notify a potentially abusive user that I'm following him/her, would you?

Following and being followed must be a mutual agreement. The idea would be to have a way to give agreement on the fact that you can be followed.

I wouldn't want to notify a potentially abusive user that I'm following him/her, would you?

How to define "potentially abusive"? What happen if someone just want to stalk someone else? There is a potential harassment issue. I've just reported that on my personal notes.

Qgil added a comment.Apr 12 2016, 11:51 AM

There seems to be two levels of acceptance here:

  • Required: users should be able to opt out of this feature altogether.
  • Required?: users should be able to know who is following them, and be able to decline requests.

Although there is a risk that this feature would ease stalking to users, it is a fact that the very established MediaWiki feature "User contributions" and related tools like "Global user contributions" are already prone to make stalking easy.

Allowing users opt out of the new feature would allow them to keep the current status quo in relation to the "watchability" of their activities. I'm less sure about the advantages of being able to decline specific persons, since that is a way to tell them "I don't want you, specifically you, to watch me". If the person willing to watch had the intention to stalk that user, that is probably an explicit motivation to do so, and the tools to do it exist. Therefore, for the end user maybe it is better to simply allow them to opt out.

How to define "potentially abusive"?

I'd often like to follow users who have been given warnings but may still benefit the project instead of getting blocked indefinitely.

What happen if someone just want to stalk someone else? There is a potential harassment issue. I've just reported that on my personal notes.

What about privacy? Even sysops don't know who is watching a page, why should someone know who is watching a user?
It'd be convenient to have the feature implemented in MediaWiki (core/extension) but if it proves suboptimal, you can be sure something better will appear on Tool Labs soon after.

In T2470#2198459, @Qgil wrote:
  • Required: users should be able to opt out of this feature altogether.

Are you suggesting that vandals who have been given a chance should be able to make harder for sysops to follow their activities?
User contributions and most other activities are public. Remember what happened with X!'s edit counter? There is no opt out.

Qgil added a comment.Apr 18 2016, 9:16 AM

I have tried to summarize the progress on this task at https://meta.wikimedia.org/wiki/Wikimedia_Blog/Drafts/WIP_Wikimedia_Hackathon_2016_post#The_connection_with_the_Community_Wishlist. Is there any beautiful screenshot in Commons that we can reuse?

DannyH added a comment.Aug 4 2016, 6:31 PM

We posted a status update on this project to the Community Tech project page:

https://meta.wikimedia.org/wiki/Community_Tech/Add_a_user_watchlist

Also posting it below for convenience, wikitext and all:

The Community Tech team has weighed the possible benefits and costs of building the user watchlist. Essentially, there are three main uses for a user watchlist:

  1. Keep track of editors that you know have vandalized pages or violated the rules, to make sure they're not causing more trouble.
  2. Help mentors and trainers to keep track of the participants in their program.
  3. (Bad faith:) Keep track of editors that you don't like, so that every time they make an edit, you can jump in and revert their edit or argue with them. This is [[w:Wikipedia:Harassment#Wikihounding|hounding]], which is against our policies.

During the Community Wishlist Survey, the people [[2015 Community Wishlist Survey/Watchlists#Add a user watchlist|who proposed and supported this idea]] were supporting #1 and #2. There's no doubt they would use it in good faith. But there were also editors in that discussion who noted that it could be used to facilitate stalking and hounding. As we’ve investigated this topic, we’ve met more and more concern about potential abuse. This was enough that we wanted to consult the Wikimedia Foundation Support and Safety team, who have a lot of experience when it comes to harassment on Wikimedia wikis. They recommended to us in no uncertain terms not to proceed.

It's true that the information being collected in this tool is already publicly available in Special:Contributions, so it's possible to argue that there's no real harm in having a tool that just makes stalking more convenient. Still, that's the same reason why people want the good faith version – it's easier to manage this as a watchlist, rather than looking at people's contributions – so it doesn't tip the scale either way.

One thing that's difficult about judging the benefits and risks is that the use of this feature would be essentially invisible. Once this tool is built and enabled, there's no way to know whether people are using it for good or bad reasons; anyone who's using it to stalk people could be doing that by looking at their contributions. If we say "Let's enable it, and see if it causes any problems," then there's no obvious signal that would make people aware of the problems.

During the survey, many people brought up possible ways to tweak the feature, which could reduce the risk.

  • We could make it opt-in, so people would only be followed if they chose to participate. That would work for use #2 – the mentor/trainer use case – but it would make #1 utterly useless.
  • We could make it opt-out, so that people who don't want to be followed could take themselves out. But there's only a tiny fraction of new users who would know about the feature – of the many things that a new contributor needs to know, "there's a user watchlist you can opt out of" isn't high on the list – so an opt-out wouldn't make any real difference.
  • We could notify people that they're being watched, so that they could opt out, but that's a scary and distracting message to send to new users, and could easily be seen as a bigger thing than it is.
  • We could make this tool available to admins, which was suggested by several people during the survey. However, a lot of vandal fighters and mentors are not administrators. Also, to be honest, as active Wikimedians, we’re aware of many cases where admins have been part of personal conflicts. While the vast majority of trusted users would of course use it in good faith, it would create the perceptions of admins having a tool that could be used for stalking, which is invisible and inaccessible to other users and beyond their control. We’ve been strongly discouraged from doing this.

Happily, there’s some good news for the #2 use case: Helping mentors and trainers keep track of the participants in their program. The Community Tech team is helping to finish the WMF [https://outreachdashboard.wmflabs.org/ Programs and Events Dashboard], a program management tool that’s specifically designed for program leaders to manage the participants in their program. There’s some more work to do on the dashboard, but we expect to finish it before the end of the year.

Would logging the list help with the stalking/hounding issue? That is, there is a (public or semi-public) log where people (either everybody or administrators) can see who is being watched by who.

DannyH added a comment.Aug 4 2016, 8:13 PM

That's an interesting question; I'm kind of running through the scenario in my head.

If user A is harassing user B on multiple pages, then you could check the log. If you see that B is on A's watchlist, then -- what? It doesn't prove that A is hounding B. The real evidence of harassment is what A is writing on those pages.

It serves as circumstantial evidence. Also, I've seen people being warned on enwiki for "following around" other editors and thus either engaging in harassment or violating interaction bans or the like.

The real evidence of harassment is what A is writing on those pages.

+1

Sn1per added a subscriber: Sn1per.Aug 12 2016, 9:05 PM

Having a way to watchlist user contributions would be useful to keep an eye on potential vandals.

For example, I just ran into a new user that has only edited Article for Deletion discussions on enwiki. That's fishy, so I'd like to keep an eye on them.

Would a feature allowing administrators to stop a user from watch listing anther users activity be a possible feature? I'm thinking along the lines of a technical method to implement an interaction ban with this feature. EX: User A is in a one way interaction ban with User B. Administrator C implements a interaction ban using some sort of interface which stops User A from being able to add User B to their activity watch list.

DannyH closed this task as Declined.Aug 12 2016, 9:30 PM

@Gestrid & @Cameron11598 : Unfortunately, there's too much risk of abuse for us to build this tool. The Community Tech team's final determination on this project is published here:

https://meta.wikimedia.org/wiki/Community_Tech/Add_a_user_watchlist

or see my comment above.

I'm going to close this task as Declined.

Restricted Application removed a subscriber: Liuxinyu970226. · View Herald TranscriptAug 12 2016, 9:30 PM
Gestrid removed a subscriber: Gestrid.Aug 12 2016, 9:42 PM

If harassment is the core concern the feature could be modified in a way to give every user a list of other users that are watching them and an option to block specific users from watching.

This would allow the positive use-case of mentoring but remove the abuse risk.

matej_suchanek removed a subscriber: wikibugs-l-list.
Qgil removed a subscriber: Qgil.Oct 4 2016, 6:49 PM

If harassment is the core concern the feature could be modified in a way to give every user a list of other users that are watching them and an option to block specific users from watching.
This would allow the positive use-case of mentoring but remove the abuse risk.

It has been suggested multiple times, mainly for mentoring, and your feedback is I think a new proof of the relevance of that strategy.

DannyH added a comment.Oct 5 2016, 8:25 PM

Unfortunately, I think a notification/opt-out system would also have a bad impact, especially for new users.

One use of the new watchlist would be: When a new editor makes an edit on a page that you care about, you put that editor on your watchlist, to make sure they don't mess something up in that category.

So as that new editor, you've made a couple of random edits, and all of a sudden you get a notification that three people are watching you, and you can block them if you want to. How would you feel about that? You don't know any of these people, you don't know why they're following you, and you don't know if they want to help you or criticize you.

I think any kind of opt-in or opt-out is going to run into problems for new users.

MZMcBride reopened this task as Open.Oct 7 2016, 3:34 AM
MZMcBride added subscribers: Gestrid, Cameron11598.

So as that new editor, you've made a couple of random edits, and all of a sudden you get a notification that three people are watching you, and you can block them if you want to. How would you feel about that? You don't know any of these people, you don't know why they're following you, and you don't know if they want to help you or criticize you.

Replace "edits" with "tweets" and replace "watching" with "following" and you describe Twitter. Replace "tweets" with "commits" and you describe GitHub. Replace "commits" with "posts" and you describe Tumblr, Facebook, and Instagram. I believe most/all of these services have block features.

While I understand your concerns, in the broader context of the present-day Web, you may be overstating matters.

@Gestrid & @Cameron11598 : Unfortunately, there's too much risk of abuse for us to build this tool. The Community Tech team's final determination on this project is published here:
https://meta.wikimedia.org/wiki/Community_Tech/Add_a_user_watchlist
or see my comment above.
I'm going to close this task as Declined.

This task predates the existence of the Wikimedia Foundation Community Tech team by about a decade. You might be empowered to control the tasks that the Community Tech team works on, but that's explicitly distinct from the ability to mark a generic request such as this as declined. Your team may view the idea as infeasible to implement and you're very welcome to share your team's views and research here. However, that opinion doesn't preclude another team of volunteers or staff from implementing this.

Replace "edits" with "tweets" and replace "watching" with "following" and you describe Twitter. Replace "tweets" with "commits" and you describe GitHub. Replace "commits" with "posts" and you describe Tumblr, Facebook, and Instagram. I believe most/all of these services have block features.

Even OpenStreetMap has a 'friends' feature (and actually no block feature, so far as I can see, but then being a friend on OSM doesn't really do much; it does make it easier to follow people's edits though).

Gestrid added a subscriber: Gestrid.Oct 7 2016, 4:01 AM

Here's a suggestion to limit harassment: Make it so that only trusted users (users with the user flag) could use this feature, sort of like some of the flags given to trusted users on English Wikipedia. We on English Wikipedia have a flag just for using Rollback. I don't see why we couldn't have a flag just for watchlisting users.

Note if mentoring is the only intention behind this feature, there's a pretty good tool - Education Dashboard which can be used for this purpose.

MusikAnimal added a subscriber: MusikAnimal.EditedOct 7 2016, 5:45 AM

This task predates the existence of the Wikimedia Foundation Community Tech team by about a decade. You might be empowered to control the tasks that the Community Tech team works on, but that's explicitly distinct from the ability to mark a generic request such as this as declined. Your team may view the idea as infeasible to implement and you're very welcome to share your team's views and research here. However, that opinion doesn't preclude another team of volunteers or staff from implementing this.

It was not entirely our decision. There was firm opposition from the Wikimedia Foundation Support and Safety team, as explained on the linked page https://meta.wikimedia.org/wiki/Community_Tech/Add_a_user_watchlist

I also think social networking sites are by a longshot much easier to wrap your head around than the wiki. I can understand the analogy, but new users of Twitter and Facebook don't get "bit", or suffer from long-term harassment like we see here.

DannyH added a comment.EditedOct 7 2016, 7:18 PM

This task predates the existence of the Wikimedia Foundation Community Tech team by about a decade. You might be empowered to control the tasks that the Community Tech team works on, but that's explicitly distinct from the ability to mark a generic request such as this as declined. Your team may view the idea as infeasible to implement and you're very welcome to share your team's views and research here. However, that opinion doesn't preclude another team of volunteers or staff from implementing this.

That's a good point; this wasn't originally the Community Tech team's ticket. If people want to keep discussing it, that's okay; our team doesn't have to be in charge of that conversation.

So, just to be super extra clear: This project was #10 on the 2015 Community Wishlist Survey, and Community Tech declined the project. Our rationale for declining the feature is posted above in T2470#2523370.

If another team is considering taking this on, I'd recommend talking to the WMF Support and Safety team before spending time on it.

I'm going to take the Community Tech and Community Wishlist Survey tags off the ticket. As far as we're concerned, this ticket is closed.

If people want to keep discussing it, that's okay; our team doesn't have to be in charge of that conversation.

Cool, thank you for being so understanding. :-)

Another potential use-case for this feature is kind of the opposite of mentoring new users: wanting to follow experienced users who make infrequent but interesting edits. I've used a pair of IRC bots that relay between irc.wikimedia.org and irc.freenode.net for this purpose for years. There are certain users on certain wikis who edit infrequently, but still often make interesting edits. A lot of current Wikimedia Foundation staff fit in this category. Users who were once highly active and no longer are also fit in this category.

I think wanting to follow/watch/stalk interesting users and their edits is similar to the reason someone might follow your account on Twitter or Facebook or Tumblr.

The harassment arguments seem very weak to me. We already have Special:Contributions with accompanying RSS and IRC feeds. Plus, y'know, browser bookmarks are still a thing. A motivated person can always follow a user in order to harass them, just as we allow a motivated person to follow a user to revert their vandalism. Punishing the helpful and useful users who want this tool to follow and contribute to Wikimedia wikis seems misguided.

The harassment arguments seem very weak to me. We already have Special:Contributions with accompanying RSS and IRC feeds. Plus, y'know, browser bookmarks are still a thing. A motivated person can always follow a user in order to harass them, just as we allow a motivated person to follow a user to revert their vandalism. Punishing the helpful and useful users who want this tool to follow and contribute to Wikimedia wikis seems misguided.

If the technology is already there (RSS and IRC), someone might be able to code a js or css plugin for the feature.

As for potential harassment, I'll just repeat what I said above:

Here's a suggestion to limit harassment: Make it so that only trusted users (users with the user flag) could use this feature, sort of like some of the flags given to trusted users on English Wikipedia. We on English Wikipedia have a flag just for using Rollback. I don't see why we couldn't have a flag just for watchlisting users.

That comment would only apply, of course, if it were an official feature and not just a plugin.

Scott added a subscriber: Scott.Jan 7 2017, 1:44 AM
jeblad added a subscriber: jeblad.EditedJan 20 2018, 4:08 PM

I wonder if this has been prematurely closed.

A "user watchlist" is nothing more than a variant of "following" on Twitter or some other site. (Ref T2470#2698582 for examples.) What makes it possible for a stalker to abuse the system is to make it invisible to other users. Reframe the problem as an open board where the users are listed with links to the new Interaction Timeline, then it will be extremely visible if someone use the tool for stalking other users.

At the same time it should be possible for users to block other from following them. That would lower the conflict level considerably. If someone block a user from following them should not imply that other users are blocked from using the Interaction Timeline to inspect interactions between two users.

Note that there should be a board for who are following the user, and who the user him-/herself is following. The user him-/herself could in addition have a contribution watchlist for those users, but that list must then respect those users blocklists.

In such a system the cost for a user to put a stalked user on the following list would simply be to high. A user watchlist without any cost will invite stalking, but with a cost it can quickly turn into system any stalker will avoid. It is even possible to add sentiment analysis to make troublesome interactions even more visible. Imagine a simple contribution score in articles where deletions spike for interactions between some users. Would a stalker want this kind of visibility?

I believe this task should be reopened.

+1000 for this cogently-put argument.

Well, no, stalking and following around does not have to be invisible. As for blocking other people from following you, some editors make bad edits and need to be followed around to clean up behind them.

I wonder if this has been prematurely closed.
[...]
I believe this task should be reopened.

This task is not closed, it is currently open. This task was marked declined from August 2016 to October 2016 and has remained open since, as far as I can tell.

Restricted Application added a project: Growth-Team. · View Herald TranscriptOct 31 2018, 10:44 AM
Ammarpad removed a subscriber: Ammarpad.EditedSep 11 2019, 11:00 AM

In case this task gets resurrected one day, I am adding my voice against it. It is a bad idea. It's a harassment enabler as the cons outweigh the pros by miles.

Elitre removed a subscriber: Elitre.Sep 11 2019, 12:09 PM

Community-Tech already decided that they won't work on it. Should we close it as declined?

Aklapper lowered the priority of this task from Normal to Low.Oct 18 2019, 6:38 AM

@Masumrezarock100: No, because this is a valid task.

Niharika removed a subscriber: Niharika.Oct 18 2019, 1:25 PM